const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const inventory_items = sequelize.define(
    'inventory_items',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

item_category: {
        type: DataTypes.ENUM,
      
      

        values: [

"feed",


"medicine",


"chemical",


"equipment",


"packaging",


"other"

        ],

      },

item_name: {
        type: DataTypes.TEXT,
      
      

      },

sku: {
        type: DataTypes.TEXT,
      
      

      },

unit: {
        type: DataTypes.TEXT,
      
      

      },

quantity_on_hand: {
        type: DataTypes.DECIMAL,
      
      

      },

reorder_level: {
        type: DataTypes.DECIMAL,
      
      

      },

unit_cost: {
        type: DataTypes.DECIMAL,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  inventory_items.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity














    db.inventory_items.hasMany(db.inventory_movements, {
      as: 'inventory_movements_inventory_item',
      foreignKey: {
          name: 'inventory_itemId',
      },
      constraints: false,
    });



















//end loop



    db.inventory_items.belongsTo(db.tenants, {
      as: 'tenant',
      foreignKey: {
        name: 'tenantId',
      },
      constraints: false,
    });

    db.inventory_items.belongsTo(db.tenant_locations, {
      as: 'location',
      foreignKey: {
        name: 'locationId',
      },
      constraints: false,
    });

    db.inventory_items.belongsTo(db.feed_products, {
      as: 'feed_product',
      foreignKey: {
        name: 'feed_productId',
      },
      constraints: false,
    });

    db.inventory_items.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.inventory_items.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.inventory_items.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return inventory_items;
};


